!!ARBfp1.0

#
# Copyright (C) 2004 Jörg Walter <jwalt@garni.ch>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

TEMP coord1, coord2, coord3, pixel0;
ALIAS pixel1 = coord1;
ALIAS pixel2 = coord2;
ALIAS pixel3 = coord3;
TEMP diff;
TEMP center_offset;
TEMP factors;

PARAM pixel_size = program.env[0];
PARAM const = { .0625, .5, .99609375, .001953125 };
ATTRIB coord0 = fragment.texcoord[0];
# r: 1/.875, b: .875 * .958 (from sdlopengl.cpp)
PARAM cap = { 1.142857142857142857127368540393064222371, -0.07142857142857143002735720305196309709572, .83825, .080875 };

TEX diff, coord0, texture[1], 2D;

MUL center_offset.xy, coord0, pixel_size.abgr;
FRC center_offset.xy, center_offset;

SUB coord3.xy, center_offset, const.g;
CMP coord3.xy, coord3, -pixel_size, pixel_size;
ADD coord3.xy, coord0, coord3;
MOV coord1.x, coord3;
MOV coord1.y, coord0;
MOV coord2.x, coord0;
MOV coord2.y, coord3;

MAD_SAT center_offset.xy, center_offset, cap.r, cap.g;
MAD center_offset.xy, center_offset, cap.b, cap.a;

MAD center_offset.x, center_offset, const, diff.a;
MAD center_offset.z, diff, const.b, const.a;

TEX pixel0, coord0, texture[0], 2D;
TEX pixel1, coord1, texture[0], 2D;
TEX pixel2, coord2, texture[0], 2D;
TEX pixel3, coord3, texture[0], 2D;
TEX factors, center_offset, texture[2], 3D;

MUL pixel0, pixel0, factors.r;
MAD pixel0, pixel1, factors.g, pixel0;
MAD pixel0, pixel2, factors.b, pixel0;
MAD result.color, pixel3, factors.a, pixel0;

#MOV result.color, pixel0;
#MOV result.color, diff;
#MOV result.color, factors;

END
